public class MergeSortTest
{

	public static void mergeSort(double[] data, double outData[])
	{
		m_sort(data, outData, 0, data.length-1);
	}


	public static void m_sort(double[] data, double outData[], int left, int right)
	{
		int mid;

		if (right > left)
		{
			mid = (right + left)/2;
			m_sort(data, outData,left, mid);
			m_sort(data,outData, mid+1, right);

			merge(data, outData, left, mid+1, right);
		}
	}


	public static void merge(double data[], double outData[], int left, int mid, int right)
	{
		int left_end;
		int nr_elements;
		int tmp_pos;
		int i = left;
		int j = mid;


		left_end = mid -1;
		tmp_pos = left;
		nr_elements = right - left + 1;


		System.out.println("Left = " + left + " mid " + mid + " right " + right);
		while ((i <= left_end) && (j <= right))
		{
			if (data[i] <= data[j])
			{
				outData[tmp_pos] = data[i];
				i++;
			} else
			{
				outData[tmp_pos] = data[j];
				j++;
			}
			tmp_pos++;
		}

		// Copy rest of first half
		while (i <= left_end)
		{
			outData[tmp_pos] = data[i];
			i++;
			tmp_pos++;
		}

		// Copy rest of second half
		while (j <= right)
		{
			outData[tmp_pos] = data[j];
			j++;
			tmp_pos++;
		}


		for (i = 0; i < nr_elements; i++)
		{
			data[right] = outData[right];
			right--;
		}
	}


    public static void main(String[] args)
    {
		double[] data = {5.0, 0.0, -2.3, -0.3, -7.0, 1.2};
		double[] sortedData = new double[data.length];

		System.out.println("Data array: ");
		print_array(data);

		mergeSort(data, sortedData);

		System.out.println("Sorted data array");
		print_array(data);

    }

    public static void print_array(double[] d)
    {
		for (int i=0; i < d.length; i++)
			System.out.print(d[i] + " ");
		System.out.println();
	}
}